#ifndef LEAPGS_H
#define LEAPGS_H

#define STATE_NONE 0
#define STATE_INITIALIZED 1
#define STATE_CONNECTED 2
#define STATE_DISCONNECTED 3
#define STATE_EXITED 4

#define GESTURE_INVALID -1
#define GESTURE_SWIPE 1
#define GESTURE_CIRCLE 4
#define GESTURE_SCREEN_TAP 5
#define GESTURE_KEY_TAP 6

int leap_init();
void leap_uninit();
int get_state();
int get_frame_id();
int get_timestamp();
int get_hand_count();
int get_finger_count(int _hand);
int get_tools_count();
int get_gestures_count();
int get_gesture_type(int _gestureId);
VECTOR* get_average_finger_pos(int _hand);
float get_sphere_radius(int _hand);
VECTOR* get_palm_position(int _hand);
float get_hand_pan(int _hand);
float get_hand_tilt(int _hand);
float get_hand_roll(int _hand);

int get_circle_gesture_id(int _id);
int get_circle_gesture_state(int _id);
int get_circle_gesture_progress(int _id);
int get_circle_gesture_radius(int _id);
int is_circle_gesture_clockwise(int _id);

int get_swipe_gesture_id(int _id);
int get_swipe_gesture_state(int _id);
VECTOR* get_swipe_gesture_direction(int _id);
int get_swipe_gesture_speed(int _id);

int get_keytap_gesture_id(int _id);
int get_keytap_gesture_state(int _id);
VECTOR* get_keytap_gesture_position(int _id);
VECTOR* get_keytap_gesture_direction(int _id);

int get_screentap_gesture_id(int _id);
int get_screentap_gesture_state(int _id);
VECTOR* get_screentap_gesture_position(int _id);
VECTOR* get_screentap_gesture_direction(int _id);

#endif