#include <acknex.h>
#include <default.c>

#include "leapgs.h"


void main() {
	level_load("");
	
	wait(3);
	
	ENTITY* entHand1 = ent_create(SPHERE_MDL, vector(50, -15, 0), NULL);
	entHand1.scale_z = 0.1;
	
	ENTITY* entHand2 = ent_create(SPHERE_MDL, vector(50, 5, 0), NULL);
	entHand2.scale_z = 0.1;
	
	int i=0;
	int initialized = leap_init();
	
	// Gestures
	int gInvalid = 0;
	int gSwipe = 0;
	int gCircle = 0;
	int gScreenTap = 0;
	int gKeyTap = 0;

	if (initialized == 0) {
		printf("Could not initialize Leap Motion. Connected?");
		return;
	}

	while(1) {
		draw_text("Hands: ", 10, 10, vector(0,255, 0));
		draw_text(str_for_int(NULL, get_hand_count()), 200, 10, vector(0,0,255));
		
		draw_text("Total fingers: ", 10, 30, vector(0,255, 0));
		draw_text(str_for_int(NULL, get_finger_count(0)+get_finger_count(1)), 200, 30, vector(0,0,255));
		
		draw_text("State: ", 10, 50, vector(0,255, 0));
		switch(get_state()) {
			case STATE_NONE:
				draw_text("None", 200, 50, vector(0,0,255));
			break;
			case STATE_INITIALIZED:
				draw_text("Initialized", 200, 50, vector(0,0,255));			
			break;
			case STATE_CONNECTED:
				draw_text("Connected", 200, 50, vector(0,0,255));			
			break;
			case STATE_DISCONNECTED:
				draw_text("Disconnected", 200, 50, vector(0,0,255));			
			break;
			case STATE_EXITED:
				draw_text("Exited", 200, 50, vector(0,0,255));			
			break;
		}
		
		draw_text("Gestures recognized: ", 10, 100, vector(0,255, 0));
		draw_text(str_for_int(NULL, get_gestures_count()), 200, 100, vector(0,0,255));
		
		if (get_gestures_count() > 0) {
			
			gInvalid = 0;
			gSwipe = 0;
			gCircle = 0;
			gScreenTap = 0;
			gKeyTap = 0;
		
			for (i=0; i<get_gestures_count(); i++) {
				switch(get_gesture_type(i)) {
					case GESTURE_INVALID:
						gInvalid +=1;
					break;
					case GESTURE_SWIPE:
						gSwipe +=1;
					break;
					case GESTURE_CIRCLE:
						gCircle +=1;
					break;
					case GESTURE_SCREEN_TAP:
						gScreenTap +=1;
					break;
					case GESTURE_KEY_TAP:
						gKeyTap +=1;
					break;
				}
			}
		}
		
		draw_text("Invalid gesture: ", 30, 1200, vector(0,255, 0));
		draw_text(str_for_int(NULL, gInvalid), 230, 1200, vector(0,0,255));
		
		draw_text("Swipe gesture: ", 30, 150, vector(0,255, 0));
		draw_text(str_for_int(NULL, gSwipe), 230, 150, vector(0,0,255));
		
		draw_text("Circle gesture: ", 30, 180, vector(0,255, 0));
		draw_text(str_for_int(NULL, gCircle), 230, 180, vector(0,0,255));
		
		draw_text("Screen tap gesture: ", 30, 210, vector(0,255, 0));
		draw_text(str_for_int(NULL, gScreenTap), 230, 210, vector(0,0,255));
		
		draw_text("Key tap gesture: ", 30, 240, vector(0,255, 0));
		draw_text(str_for_int(NULL, gKeyTap), 230, 240, vector(0,0,255));
		
		

		draw_text("Hand 1 pan: ", 10, 300, vector(0,255, 0));
		draw_text(str_for_int(NULL, get_hand_pan(0)), 200, 300, vector(0,0,255));		
		
		draw_text("Hand 1 tilt: ", 10, 330, vector(0,255, 0));
		draw_text(str_for_int(NULL, get_hand_tilt(0)), 200, 330, vector(0,0,255));
	
		draw_text("Hand 1 roll: ", 10, 360, vector(0,255, 0));
		draw_text(str_for_int(NULL, get_hand_roll(0)), 200, 360, vector(0,0,255));
		
		entHand1.pan = get_hand_pan(0);
		entHand1.tilt = get_hand_tilt(0);
		entHand1.roll = get_hand_roll(0);
		
		entHand2.pan = get_hand_pan(1);
		entHand2.tilt = get_hand_tilt(1);
		entHand2.roll = get_hand_roll(1);		
		wait(1);
	}
}